## ros-humble-io-context 1.2.0

=== CMakeLists.txt ===
# Copyright 2021 Apex.AI, Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Co-developed by Tier IV, Inc. and Apex.AI, Inc.
# Maintained by LeoDrive, 2021

cmake_minimum_required(VERSION 3.5)
project(io_context)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

## dependencies
find_package(ament_cmake_auto REQUIRED)
ament_auto_find_build_dependencies()

find_package(asio_cmake_module REQUIRED)
find_package(ASIO REQUIRED)

ament_auto_add_library(${PROJECT_NAME} SHARED
  src/io_context.cpp
  src/msg_converters/std_msgs.cpp
)
ament_target_dependencies(${PROJECT_NAME} "ASIO")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
  get_filename_component(name test_io_context NAME_WLE)
  set(TEST_UDP_DRIVER_EXE ${name})

  ament_add_gtest(${TEST_UDP_DRIVER_EXE}
          test/${name}.cpp)
  ament_target_dependencies(${TEST_UDP_DRIVER_EXE} std_msgs udp_msgs "ASIO")

  target_include_directories(${TEST_UDP_DRIVER_EXE} PRIVATE include)
  target_link_libraries(${TEST_UDP_DRIVER_EXE} ${PROJECT_NAME})
endif()

target_compile_options(${PROJECT_NAME} PUBLIC "-O0" PRIVATE -Wall)

ament_auto_package(
  CONFIG_EXTRAS_POST "io_context-extras.cmake"
)

=== debian/changelog ===
ros-humble-io-context (1.2.0-2jammy) jammy; urgency=high

  * Fix linter errors.
  * Contributors: WhitleySoftwareServices

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Sun, 20 Mar 2022 07:00:00 -0000

ros-humble-io-context (1.1.0-2jammy) jammy; urgency=high

  * Fix the converter Converter between std_msgs::msg::UInt8MultiArray and std::vector<uint8_t> (#73 <https://github.com/ros-drivers/transport_drivers/issues/73>)
    * example_interfaces is redundant as std_msgs includes UInt8MultiArray
    * udp_msgs.hpp should not include "converters.hpp"
    * Fix the converter std_msgs::msg::UInt8MultiArray <-> std::vector<uint8_t>
  * Add a second constructor to avoid comparing size_t (unsigned int) and int (#70 <https://github.com/ros-drivers/transport_drivers/issues/70>)
  * Fix cpplint error (#69 <https://github.com/ros-drivers/transport_drivers/issues/69>)
    See https://build.ros2.org/job/Gdev__transport_drivers__ubuntu_focal_amd64/9/testReport/junit/(root)/projectroot/cpplint/
  * Contributors: ChenJun, Esteve Fernandez

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Sun, 20 Mar 2022 07:00:00 -0000

ros-humble-io-context (1.0.1-2jammy) jammy; urgency=high

  * Serial driver debugs (#56 <https://github.com/ros-drivers/transport_drivers/issues/56>)
    * debugged message conversion
    debugged serial bridge segfault (publisher accessed before initialized)
    * refactored message conversion
  * update READMEs for each package (#54 <https://github.com/ros-drivers/transport_drivers/issues/54>)
    * update READMEs for each package
    * add more to readme, renamed config to params
  * use vectors not mutbuffers (#50 <https://github.com/ros-drivers/transport_drivers/issues/50>)
  * Port udp_driver Changes to serial_driver (#47 <https://github.com/ros-drivers/transport_drivers/issues/47>)
    * Adding SerialPort and framework for SerialDriver.
    * Adding SerialDriver
    * Adding SerialBridgeNode
    * Remove serial_driver_node and tests
    * Create new tests for serial_port and serial_driver
    * Changing signature of from_msg for example_interfaces
    * [serial_driver] Adding missing function definition
    * [serial_driver] Adding example params and launch files
    * Trying to apease flake8
    * Fixing allocation snafu
    * [serial_driver] Replacing MutBuffer with std::vector<uint8_t>
    * [serial_driver] Fix typo
    * [serial_driver] Make launch file more reliable
    * [serial_driver] Fix error message
    * [serial_driver] Fix typo
    * [serial_driver] Shorten node name
  * Generic udp nodes (#40 <https://github.com/ros-drivers/transport_drivers/issues/40>)
    * use udp_msgs for receiver and sender nodes
    * use vector of uint8_ts instead of mutable buffer
    * all tests passing
  * Rename MutSocketBuffer to MutBuffer (#46 <https://github.com/ros-drivers/transport_drivers/issues/46>)
  * Export ASIO definitions (#44 <https://github.com/ros-drivers/transport_drivers/issues/44>)
  * Enforce C++14. Do not duplicate compiler flags (#45 <https://github.com/ros-drivers/transport_drivers/issues/45>)
  * Deduplicate ASIO CMake module (#43 <https://github.com/ros-drivers/transport_drivers/issues/43>)
    * Added ASIO CMake module
    * Use asio_cmake_module
  * Use RCLCPP logging macros (#42 <https://github.com/ros-drivers/transport_drivers/issues/42>)
  * Fix copyright years (#41 <https://github.com/ros-drivers/transport_drivers/issues/41>)
  * Removed Boost (#39 <https://github.com/ros-drivers/transport_drivers/issues/39>)
    * Removed Boost
    * Do not depend on Boost at all
    * Added cmath header
    * Fix linting warning
    * Added ASIO_STANDALONE to more units
    * Call stop on io_service
    * Fix dependency
    * Export asio as a downstream dependency
    * Remove more boost references
    * Force non-Boost version of ASIO
    * Force non-Boost version of ASIO
    * Ignore result to avoid compiler warning
  * Create Full UDP Nodes (#38 <https://github.com/ros-drivers/transport_drivers/issues/38>)
    * Reorganize namespaces
    * Apply reviewer feedback
    * Create UdpReceiverNode as LifecycleNode
    * Create UdpSenderNode as Lifecycle Node
    * Adding bridge node
    * Add comment to bridge node about purpose
  * Reorg namespaces (#37 <https://github.com/ros-drivers/transport_drivers/issues/37>)
    * Move UDP driver node to correct location
    * Reorganize namespaces
    * Remove unused include_directories
    * Apply reviewer feedback
  * move io_context to shared lib (#36 <https://github.com/ros-drivers/transport_drivers/issues/36>)
  * Contributors: Esteve Fernandez, Evan Flynn, Haoru Xue, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Mon, 30 Aug 2021 07:00:00 -0000

ros-humble-io-context (0.0.6-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 27 Aug 2020 07:00:00 -0000

ros-humble-io-context (0.0.5-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 16 Jul 2020 07:00:00 -0000

ros-humble-io-context (0.0.4-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 12 Dec 2019 08:00:00 -0000

ros-humble-io-context (0.0.3-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Wed, 21 Aug 2019 07:00:00 -0000

ros-humble-io-context (0.0.2-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Mon, 19 Aug 2019 07:00:00 -0000

=== debian/control ===
Source: ros-humble-io-context
Section: misc
Priority: optional
Maintainer: Joshua Whitley <whitleysoftwareservices@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, ros-humble-ament-cmake-auto, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-asio-cmake-module, ros-humble-rclcpp, ros-humble-std-msgs, ros-humble-udp-msgs, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-io-context
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libasio-dev, ros-humble-rclcpp, ros-humble-std-msgs, ros-humble-udp-msgs, ros-humble-ros-workspace
Description: A library to write Synchronous and Asynchronous networking applications

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-io-context//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
